import 'dart:async';
import 'dart:ffi';

import 'package:flutter/services.dart';

class FuzzyPlugin {
  static const MethodChannel _channel = MethodChannel('fuzzy_plugin');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<List<String>> fuzzySystems() async {
    final List<dynamic>? systems =
        await _channel.invokeListMethod("getFuzzySystems");
    return systems!.cast<String>();
  }

  static Future<bool> load(String json) async {
    final bool success = await _channel.invokeMethod("load", {"json": json});
    return success;
  }
}
